Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Interface ExternalObjectModel

All Known Implementing Classes:
  DOM4JObjectModel, DOMEnvelope, DOMObjectModel, JDOMObjectModel, XOMObjectModel

    public interface ExternalObjectModel

This interface must be implemented by any third-party object model that can be wrapped with a wrapper that implements the Saxon Object Model (the NodeInfo interface).

This interface is designed to enable advanced applications to implement and register new object model implementations that Saxon can then use without change. Although it is intended for external use, it cannot at this stage be considered part of the stable Saxon Public API. In particular, it is likely that the interface will grow by the addition of new methods.

Method Summary
`Value` | `convertObjectToXPathValue(Object object, Configuration config)` Convert a Java object to an XPath value.
`Object` | `convertToNodeList(SequenceExtent extent)` Convert a sequence of values to a NODELIST, as defined in the JAXP XPath API spec.
`Object` | `convertXPathValueToObject(Value value, Class targetClass, XPathContext context)` Convert an XPath value to an object in this object model.
`Receiver` | `getDocumentBuilder(Result result)` Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
`boolean` | `isRecognizedNode(Object object)` Test whether this object model recognizes a given node as one of its own.
`boolean` | `isRecognizedNodeClass(Class nodeClass)` Test whether this object model recognizes a given class as representing a node in that object model.
`boolean` | `isRecognizedNodeListClass(Class nodeClass)` Test whether this object model recognizes a given class as representing a list of nodes in that object model.
`boolean` | `sendSource(Source source, Receiver receiver, PipelineConfiguration pipe)` Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
`NodeInfo` | `unravel(Source source, Configuration config)` Wrap or unwrap a node using this object model to return the corresponding Saxon node.
`DocumentInfo` | `wrapDocument(Object node, String baseURI, Configuration config)` Wrap a document node in the external object model in a document wrapper that implements the Saxon DocumentInfo interface
`NodeInfo` | `wrapNode(DocumentInfo document, Object node)` Wrap a node within the external object model in a node wrapper that implements the Saxon VirtualNode interface (which is an extension of NodeInfo)

Method Detail

### isRecognizedNode

    boolean isRecognizedNode(Object object)

  Test whether this object model recognizes a given node as one of its own. This method will generally be called at run time.

  Parameters:
    `object` - An object that possibly represents a node
  Returns:
    true if the object is a representation of a node in this object model

### isRecognizedNodeClass

    boolean isRecognizedNodeClass(Class nodeClass)

  Test whether this object model recognizes a given class as representing a node in that object model. This method will generally be called at compile time.

  Parameters:
    `nodeClass` - A class that possibly represents nodes
  Returns:
    true if the class is used to represent nodes in this object model

### isRecognizedNodeListClass

    boolean isRecognizedNodeListClass(Class nodeClass)

  Test whether this object model recognizes a given class as representing a list of nodes in that object model. This method will generally be called at compile time.

  Parameters:
    `nodeClass` - A class that possibly represents nodes
  Returns:
    true if the class is used to represent nodes in this object model

### getDocumentBuilder

    Receiver getDocumentBuilder(Result result)
                                throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, return null.

  Throws:
    `XPathException`

### sendSource

    boolean sendSource(Source source,
                       Receiver receiver,
                       PipelineConfiguration pipe)
                       throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false.

  Throws:
    `XPathException`

### unravel

    NodeInfo unravel(Source source,
                     Configuration config)

  Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null

### convertObjectToXPathValue

    Value convertObjectToXPathValue(Object object,
                                    Configuration config)
                                    throws XPathException

  Convert a Java object to an XPath value. If the supplied object is recognized as a representation of a value using this object model, the object model should convert the value to an XPath value and return this as the result. If not, it should return null. If the object is recognized but cannot be converted, an exception should be thrown

  Throws:
    `XPathException`

### convertXPathValueToObject

    Object convertXPathValueToObject(Value value,
                                     Class targetClass,
                                     XPathContext context)
                                     throws XPathException

  Convert an XPath value to an object in this object model. If the supplied value can be converted to an object in this model, of the specified class, then the conversion should be done and the resulting object returned. If the value cannot be converted, the method should return null. Note that the supplied class might be a List, in which case the method should inspect the contents of the Value to see whether they belong to this object model.

  Throws:
    `XPathException` - if the target class is explicitly associated with this object model, but the supplied value cannot be converted to the appropriate class

### wrapDocument

    DocumentInfo wrapDocument(Object node,
                              String baseURI,
                              Configuration config)

  Wrap a document node in the external object model in a document wrapper that implements the Saxon DocumentInfo interface

  Parameters:
    `node` - a node (any node) in the third party document
    `baseURI` - the base URI of the node (supply "" if unknown)
    `config` - the Saxon configuration (which among other things provides access to the NamePool)
  Returns:
    the wrapper, which must implement DocumentInfo

### wrapNode

    NodeInfo wrapNode(DocumentInfo document,
                      Object node)

  Wrap a node within the external object model in a node wrapper that implements the Saxon VirtualNode interface (which is an extension of NodeInfo)

  Parameters:
    `document` - the document wrapper, as a DocumentInfo object
    `node` - the node to be wrapped. This must be a node within the document wrapped by the DocumentInfo provided in the first argument
  Returns:
    the wrapper for the node, as an instance of VirtualNode

### convertToNodeList

    Object convertToNodeList(SequenceExtent extent)

  Convert a sequence of values to a NODELIST, as defined in the JAXP XPath API spec. This method is used when the evaluate() request specifies the return type as NODELIST, regardless of the actual results of the expression. If the sequence contains things other than nodes, the fallback is to return the sequence as a Java List object. The method can return null to invoke fallback behaviour.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.